function sys=configc(name)
%CONFIGC Loads system configuration information based on given name. 
%User may edit here new setup data.
if strcmp(name,'sony')
  sys = [
      768,     %number of pixels in horizontal direction
      576,     %number of pixels in vertical direction
      6.2031,  %effective CCD chip size in horizontal direction
      4.6515,  %effective CCD chip size in vertical direction
      8.5,     %nominal focal length
      5,       %radius of the circular control points
      0,       %for future expansions
      0,
      0,
      abs(name)'
  ];
  return;
end

if strcmp(name,'sonyz')
  sys = [
      768,     %number of pixels in horizontal direction
      576,     %number of pixels in vertical direction
      6.2031,  %effective CCD chip size in horizontal direction
      4.6515,  %effective CCD chip size in vertical direction
      8.5,     %nominal focal length
      0,       %radius of the circular control points
      0,       %for future expansions
      0,
      0,
      abs(name)'
  ];
  return;
end
 
if strcmp(name,'canon')
  sys = [
      2304,     %number of pixels in horizontal direction
      3456,     %number of pixels in vertical direction
      16,  %effective CCD chip size in horizontal direction
      24,  %effective CCD chip size in vertical direction
      58,      %nominal focal length
      10,      %radius of the circular control points
      0,       %for future expansions
      0,
      0,
      abs(name)'
  ];
  return;
end

if strcmp(name,'pulnix')
  sys = [
      1040,     %number of pixels in horizontal direction
      1392,     %number of pixels in vertical direction
      6.402,  %effective CCD chip size in horizontal direction
      8.536,  %effective CCD chip size in vertical direction
      35,      %nominal focal length
      10,      %radius of the circular control points
      0,       %for future expansions
      0,
      0,
      abs(name)'
  ];
  return;
end

if strcmp(name,'pulnix1')
  sys = [
      1392,     %number of pixels in horizontal direction
      1040,     %number of pixels in vertical direction
      8.536,  %effective CCD chip size in horizontal direction
      6.402,  %effective CCD chip size in vertical direction
      35,      %nominal focal length
      10,      %radius of the circular control points
      0,       %for future expansions
      0,
      0,
      abs(name)'
  ];
  return;
end

if strcmp(name,'Miktron75')
  sys = [
      1024,     %number of pixels in horizontal direction
      1280,     %number of pixels in vertical direction
      13.3333%20,  %effective CCD chip size in horizontal direction
      16.6667%25,  %effective CCD chip size in vertical direction
      75,      %nominal focal length
      10,      %radius of the circular control points
      0,       %for future expansions
      0,
      0,
      abs(name)'
  ];
  return;
end

if strcmp(name,'Miktron50')
  sys = [
      1024,     %number of pixels in horizontal direction
      1280,     %number of pixels in vertical direction
      13.3333%20,  %effective CCD chip size in horizontal direction
      16.6667%25,  %effective CCD chip size in vertical direction
      50,      %nominal focal length
      10,      %radius of the circular control points
      0,       %for future expansions
      0,
      0,
      abs(name)'
  ];
  return;
end

if strcmp(name,'Miktron0')
  sys = [
      1024,     %number of pixels in horizontal direction
      1280,     %number of pixels in vertical direction
      20,  %effective CCD chip size in horizontal direction
      25,  %effective CCD chip size in vertical direction
      75,      %nominal focal length
      0,      %radius of the circular control points
      0,       %for future expansions
      0,
      0,
      abs(name)'
  ];
  return;
end

error('Unknown camera type')
