function [xyn,dy] = find_shift(name,px,py,xy,par,pos)
% find vertical shift of circles in the print of calibration chart
% input: 
% par,pos -- camera parameters
% px,py   -- x- y- coordinates of feature points
% xy      -- ideal xy coordinate of the 3D control points
dim = (size(px));
if dim(2)>dim(1)
    px = px'; 
    py = py'; % make sure that the data is organized in columns
end
if size(xy,1)==2
    xy=xy'; % make sure that the data is organized in columns
end

sys=configc(name);

v0 = zeros(10,1);
e0 = project_min(v0,sys,px,py,xy,par,pos)
v = fminsearch(@(v) project_min(v,sys,px,py,xy,par,pos),v0);
e = project_min(v,sys,px,py,xy,par,pos) 

dy =v;
for i =1:10
    xy(i:10:end,2) = v(i)+xy(i:10:end,2);
end
xyn =xy;
end

function e = project_min(v,sys,px,py,xy,par,pos)
for i =1:10
    xy(i:10:end,2) = v(i)+xy(i:10:end,2);
end
e = re_project(sys,px,py,xy,par,pos);
end

function e = re_project(sys,px,py,xy,par,pos)
[num_point,num_frame] = size(px);
xyz = [xy,zeros(num_point,1)];
n = [0,0,1]; % normal vector of the calibration target
n=n(ones(num_point,1),:);
Bs=cinit(sys,xyz,n);
for i=1:num_frame
    [cx,cy,ra,rb,ang]=cmodel1(sys,Bs,pos(:,i),par);
    e(i) = sum((px(:,i)-cx(:)).^2 + (py(:,i)-cy(:)).^2);
end
e = sum(e);
end