function test_ellipse()
% this function test error distribution of ellipse detection using
% synthetic data. 

% synthetic data to be consistent with 
% "Moment and Curvature Preserving Technique for Accurate Ellipse Boundary
% Detection", Janne Heikkila, CVPR 1996

a = rand(1,100)*6+7 ; % a  = [7,13]
b = rand(1,100)*4+3 ; % b  = [3,7]
the = rand(1,100)*pi*2-pi ; % the  = [-pi,pi]
cx = rand(1,100)+20 ; % cx  = [20,21]
cy = rand(1,100)+20 ; % cy  = [20,21]

t_t = 0;
h = fspecial('Gaussian', [30,30], 6);
for i =1 :100
    xmax = 500; s = 41/xmax;
    [x,y]=meshgrid(1:xmax,1:xmax);
    I = ones(size(x))+149; % background intensity =150
    x1 = x(:)*s-cx(i);
    y1 = y(:)*s-cy(i);
    % [cos(the), sin(the);-sin(the),cos(the)]
    x2 = x1.*cos(the(i)) + y1.*sin(the(i));
    y2 = -x1.*sin(the(i)) + y1.*cos(the(i));
    c = x2.^2./a(i)^2 + y2.^2./b(i)^2 ;
    idx = find (c<1);
    I(idx) = 50; % foreground intensity = 50
    I = imfilter(I,h,'same','conv');
%     imshow(I)
%     image(I)
%     ellipse(a(i)/s,b(i)/s,the(i),cx(i)/s,cy(i)/s,'b');
    
%     I = imresize(I,s,'bilinear');
    I = imrescale(I,s);
    % image noise
    I = I + 2*randn(size(I));
%     figure
%     imshow(I)
%     image(I)
    v0 = [a(i),b(i),the(i),20.5,20.5]';
        time1 = cputime;
    v = centre_ellipse_moid(v0,[4,5],I);
        tt = cputime - time1;
        t_t = t_t + tt;
  
    dcx(i) = v(4)- cx(i);
    dcy(i) = v(5)- cy(i);

end

stddcx= std(dcx)
stddcy= std(dcy)
% stddcx1= std(dcx1)
% stddcy1= std(dcy1)
t_t
end

function I1 = imrescale(I,s)
[H,W] = size(I);
H1 = round(H*s);
W1 = round(W*s);
[x,y] = meshgrid(1:H1,1:W1);
i = ceil(x(:)/s); j = ceil(y(:)/s);
i_1 = i-1; j_1 = j-1;
ix = x(:)/s-i+1; jy = y(:)/s-j+1;
b1 = I( j_1(:)+(i_1(:)-1)*H   );
b2 = I(j_1(:)+(i(:)-1)*H) - I(j_1(:)+(i_1(:)-1)*H);
b3 = I(j(:)+(i_1(:)-1)*H) - I(j_1(:)+(i_1(:)-1)*H);
b4 = I(j_1(:)+(i_1(:)-1)*H) - I(j_1(:)+(i(:)-1)*H) ...
    - I(j(:)+(i_1(:)-1)*H) + I(j(:)+(i(:)-1)*H);
v = b1 + b2.*ix(:) + b3.*jy(:) +b4.*ix(:).*jy(:) ;
I1 = reshape(v,H1,W1);
end